#define FIX_EARSPEAKER /* 160 words */
/******************************************************************/
#ifdef FIX_EARSPEAKER
/* Fix EarSpeaker initialization problem. */
extern __y u_int16 earSpeakerFreq;
extern __y u_int16 earSpeakerSetting;

#define HB_BUF_SIZE 2048
extern s_int16 __y stereoHalfBuf[HB_BUF_SIZE];
extern const s_int16 xternGains[];
extern const s_int16 xternDelays[];
extern struct ER {
    s_int16 samplesSinceHighVolume;
    s_int16 dryOffset;
    s_int16 halfOffset;
    s_int16 xOffset;
    s_int16 erOffset;
    s_int16 itd;
    u_int16 rir;
    s_int16 depth;
    s_int16 shiftLeft;  //Shift left for 8-bit storage to stereoHalfBuf
} er;
#define DELAY_AND_GAIN_SIZE 18
struct DelayAndGain {s_int16 __y *p;s_int16 shift;s_int16 gain;};
extern __y struct DelayAndGain delayAndGain[2][DELAY_AND_GAIN_SIZE];

auto void FixedInitXtern(register __c0 u_int16 sampleRate, u_int16 rirri) {
  register int k;
  if (sampleRate < 16000)
      sampleRate = 16000;
#if 0
  er.samplesSinceHighVolume = 0;
  er.dryOffset = er.halfOffset = er.xOffset = er.erOffset = 0;
#else
  memset(&er, 0, sizeof(er));
#endif
  er.itd = sampleRate / 1550;
  er.rir   = rirri; /* To detect fixed setup */
  er.depth = 28000;
  er.shiftLeft = 8;

  for (k=0; k<DELAY_AND_GAIN_SIZE*2; k++) {
      /* changed back to unsigned division because shift not actually
	 used in asm version */
      register s_int16 sh =
	  (u_int32)sampleRate * abs(xternDelays[/*18*i+*/k]) / (44100L<<4);
      delayAndGain[/*i*/+0][k].p     = &stereoHalfBuf[HB_BUF_SIZE-1] - sh;
      delayAndGain[/*i*/+0][k].gain  = xternGains[/*18*i+*/k];
  }
}
/* Fix the init afterwards.
   Does not need so much patch code when done in this way. */
s_int16 ApplAddr(register __i0 s_int16 **d, register __a1 s_int16 mode,
		 register __a0 s_int16 n) {
    if (mode == APPL_AUDIO) {
	if (earSpeakerFreq != 0 && er.rir == earSpeakerSetting) {
	    FixedInitXtern(earSpeakerFreq, earSpeakerSetting-1/* to detect change */);
	}
    }
    return n;
}
#endif
/******************************************************************/
